// LSystemView.cpp : implementation of the CLSystemView class
//

#include "stdafx.h"
#include "LSystem.h"

#include "LSystemDoc.h"
#include "LSystemView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CLSystemView

IMPLEMENT_DYNCREATE(CLSystemView, CView)

BEGIN_MESSAGE_MAP(CLSystemView, CView)
	//{{AFX_MSG_MAP(CLSystemView)
	ON_WM_PAINT()
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLSystemView construction/destruction

CLSystemView::CLSystemView()
{
	// TODO: add construction code here
}

CLSystemView::~CLSystemView()
{
}

BOOL CLSystemView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CLSystemView drawing

void CLSystemView::OnDraw(CDC* pDC)
{
	CLSystemDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here
}

/////////////////////////////////////////////////////////////////////////////
// CLSystemView diagnostics

#ifdef _DEBUG
void CLSystemView::AssertValid() const
{
	CView::AssertValid();
}

void CLSystemView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CLSystemDoc* CLSystemView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CLSystemDoc)));
	return (CLSystemDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CLSystemView message handlers

void CLSystemView::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	CRect r;
	CLSystemDoc *pDoc = GetDocument();
	
	// TODO: Add your message handler code here

	if (pDoc->beg == NULL) return;
	GetClientRect(&r);
	int dx, dy;
	int mx = r.Width() - 1;
	int my = r.Height() - 1;
	double x = pDoc->x_max - pDoc->x_min;
	double y = pDoc->y_max - pDoc->y_min;
	double scale;
	if (x / y > (double)mx / my)
	{
		scale = mx / x;
		dx = 0;
		dy = (int)(my - y * scale) >> 1;
	}
	else
	{
		scale = my / y;
		dx = (int)(mx - x * scale) >> 1;
		dy = 0;
	}

	XYList *l = pDoc->beg;
	while (l)
	{
		int x1 = int((l -> x1 - pDoc->x_min) * scale);
		int y1 = int((l -> y1 - pDoc->y_min) * scale);
		int x2 = int((l -> x2 - pDoc->x_min) * scale);
		int y2 = int((l -> y2 - pDoc->y_min) * scale);
		dc.MoveTo(x1 + dx, my - (y1 + dy));
		dc.LineTo(x2 + dx, my - (y2 + dy));
		l = l -> next;
	}

 // Do not call CFrameWnd::OnPaint() for painting messages
}

void CLSystemView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
	// TODO: Add your specialized code here and/or call the base class
	InvalidateRect(NULL, TRUE);	
}

int CLSystemView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	SetClassLong(m_hWnd, GCL_HBRBACKGROUND, (long)GetStockObject(WHITE_BRUSH));

	// TODO: Add your specialized creation code here
	
	return 0;
}
