// ParamsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "LSystem.h"
#include "ParamsDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CParamsDlg dialog

const char alphabet[] = "FXYb+-[]";

CParamsDlg::CParamsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CParamsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CParamsDlg)
	//}}AFX_DATA_INIT
}


void CParamsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CParamsDlg)
	DDX_Text(pDX, IDC_EDIT2, m_Axiom);
	DDV_MaxChars(pDX, m_Axiom, 64);
	DDX_Text(pDX, IDC_EDIT3, m_NewF);
	DDV_MaxChars(pDX, m_NewF, 64);
	DDX_Text(pDX, IDC_EDIT4, m_NewX);
	DDV_MaxChars(pDX, m_NewX, 64);
	DDX_Text(pDX, IDC_EDIT5, m_NewY);
	DDV_MaxChars(pDX, m_NewY, 64);
	DDX_Text(pDX, IDC_EDIT6, m_Newb);
	DDV_MaxChars(pDX, m_Newb, 64);
	DDX_Text(pDX, IDC_EDIT7, m_AngleStep);
	DDV_MinMaxInt(pDX, m_AngleStep, 1, 32);
	DDX_Text(pDX, IDC_EDIT8, m_StartAngle);
	DDV_MinMaxInt(pDX, m_StartAngle, -32, 32);
	DDX_Text(pDX, IDC_EDIT1, m_Iterations);
	DDV_MinMaxInt(pDX, m_Iterations, 0, 20);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CParamsDlg, CDialog)
	//{{AFX_MSG_MAP(CParamsDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CParamsDlg message handlers

bool CParamsDlg::ValidateString(const char *s)
{
	bool r;

	for (unsigned i = 0; i < strlen(s); i++)
	{
		r = false;
		for (unsigned j = 0; j < strlen(alphabet); j++)
			if (s[i] == alphabet[j]) r = true;
		if (!r) return false;
	}

	return true;
}

void CParamsDlg::OnOK() 
{
	// TODO: Add extra validation here
	UpdateData();
	bool r = true;
	r &= ValidateString((LPCTSTR)m_Axiom);
	r &= ValidateString((LPCTSTR)m_NewF);
	r &= ValidateString((LPCTSTR)m_NewX);
	r &= ValidateString((LPCTSTR)m_NewY);
	r &= ValidateString((LPCTSTR)m_Newb);
	if (!r)
	{
		MessageBox("      ", 
			"", MB_OK + MB_ICONEXCLAMATION);
		return;
	}
	if (!strlen(m_Axiom))
	{
		MessageBox(" \"\"    ", 
			"", MB_OK + MB_ICONEXCLAMATION);
		return;
	}
	if (!strlen(m_NewF))
	{
		MessageBox(" \"  F\"    ", 
			"", MB_OK + MB_ICONEXCLAMATION);
		return;
	}
	CDialog::OnOK();
}
